// button form

#include "solid.inc"

#declare flat = 0.5
#declare dens = 1.0
#declare size = 1.0
#declare point = 1/3
#declare slap = .15
#declare top = .29

#declare conearrow = difference {
   union {
      cone {
         <0, 0, 0>, size
         <size-slap, 0, 0>, top
         scale <2, 1, flat>
      }
      sphere {
         <size-point, 0, 0>, point
         scale <2, 1, flat>
      }
   }
   union {
      cone {
         <-2*size, 0, 0>, sqrt(5*size)
         <-2*size, 0, -flat>, sqrt(6*size)
         scale <2, 1, 1>
      }
      cone {
         <-2*size, 0, 100>, sqrt(5*size)
         <-2*size, 0, -100>, sqrt(5*size)
         scale <2, 1, 1>
      }
   }
   texture { Solid }
}

#declare conebed = difference {
   union {
      cone {
         <0, 0, 0>, size
         <size-slap, 0, 0>, top
         scale <2, 1, 1000>
      }
      sphere {
         <size-point, 0, 0>, point
         scale <2, 1, 1000>
      }
   }
   union {
      cone {
         <-2*size, 0, 0>, sqrt(5*size)
         <-2*size, 0, -flat>, sqrt(6*size)
         scale <2, 1, 1000>
      }
      cone {
         <-2*size, 0, 100>, sqrt(5*size)
         <-2*size, 0, -100>, sqrt(5*size)
         scale <2, 1, 1000>
      }
   }
   texture { Solid1 }
}

light_source { <-15, 30, -25> color red 1.5 green 1.5 blue 1.5 }
light_source { <-30, 20, -25> color red 1.5 green 1.5 blue 1.5 }
light_source { < 20,-30, -25> color red .1 green .1 blue 1 }

#declare flash = light_source { <-5, 5, -25> color red 1 green 1 blue 1 }

#declare arrow = object { conearrow }
#declare bed = object { conebed }

#declare back = difference {
  box {
    <-20, -20, 0>, <20, 20, 0.1>
    texture {
      pigment { red 1 green 0 blue 1 }
      finish { ambient 1.0 diffuse 0.0 }
    }
  }
  object { bed }
}

