// button form

#include "solid.inc"

#declare blobbutton = blob {
  threshold 0.6
  sphere { <0, 0, 0>, 1, 1.1
           scale <4.5, 3, 1> }
  sphere { < .33, .42, 0>, .7, .7
           scale <4.5, 3, 1> }
  sphere { < .40, .0, 0>, .7, .2
           scale <4.5, 3, 1> }
  sphere { < .33,-.42, 0>, .7, .7
           scale <4.5, 3, 1> }
  sphere { <-.33, .42, 0>, .7, .7
           scale <4.5, 3, 1> }
  sphere { <-.40, .0, 0>, .7, .2
           scale <4.5, 3, 1> }
  sphere { <-.33,-.42, 0>, .7, .7
           scale <4.5, 3, 1> }

  texture { Solid }

  rotate z*90
  scale <1+1/3, 2/3, 1> 
}

#declare cylbutton = cylinder {
  <-3.15, 0, 0>, <3.15, 0, 0>, 2.3
  scale <1, 1, 0.5>
  texture { Solid }
}

#declare flat = 0.5
#declare dens = 1.0
#declare size = 1.0

#declare rcylbutton = merge {
  cylinder {
    <-size, 0, 0>, <size, 0, 0>, size
    scale <1, 1, flat>
  }
  sphere {
    <-size/dens, 0, 0>, size
    scale <dens, 1, flat>
  }
  sphere {
    < size/dens, 0, 0>, size
    scale <dens, 1, flat>
  }
  texture { Solid }
}

#declare cylbed = box {
  <-3.15, 2.3, 2>, <3.15, -2.3, -1>
  texture { Solid1 }
}

#declare rcylbed = merge {
  cylinder { <-size/dens, 0, 2>, <-size/dens, 0, -1>, size
             scale <dens, 1, 1> }
  cylinder { < size/dens, 0, 2>, < size/dens, 0, -1>, size
             scale <dens, 1, 1> }
  box {
    <-size, -size, 2>, <size, size, -1>
  }
  texture { Solid1 }
}

light_source { <-15, 30, -25> color red 1.5 green 1.5 blue 1.5 }
light_source { <-30, 20, -25> color red 1.5 green 1.5 blue 1.5 }
light_source { < 20,-30, -25> color red .1 green .1 blue 1 }

#declare flash = light_source { <-5, 5, -25> color red 1 green 1 blue 1 }

#declare button = object { rcylbutton }
#declare bed = object { rcylbed }

difference {
  box {
    <-20, -20, 0>, <20, 20, 0.1>
    texture {
      pigment { red 1 green 0 blue 1 }
      finish { ambient 1.0 diffuse 0.0 }
    }
  }
  object { bed }
}

