// button form

#include "solid.inc"

#declare flat = 0.5
#declare dens = 1.0
#declare size = 1.0
#declare minor = 0.1

#declare rcylbody = union {
   cylinder {
      <-2*size, 0, 0>, <2*size, 0, 0>, size
      scale <1, 1, flat>
   }
   sphere {
      <-2*size/dens, 0, 0>, size
      scale <dens, 1, flat>
   }
   sphere {
      < 2*size/dens, 0, 0>, size
      scale <dens, 1, flat>
   }
   texture { Solid }
}

#declare rcylslider = difference {
   object { rcylbody }
   union {
      torus { size+minor, minor
              rotate 90*z
              scale <1, 1+minor, flat-flat*minor>
              translate <       0, 0, 0> }
      torus { size+minor, minor
              rotate 90*z
              scale <1, 1+minor, flat-flat*minor>
              translate < 2.5*minor, 0, 0> }
      torus { size+minor, minor
              rotate 90*z
              scale <1, 1+minor, flat-flat*minor>
              translate <-2.5*minor, 0, 0> }
      texture { Solid }
   }
}

light_source { <-15, 30, -25> color red 1.5 green 1.5 blue 1.5 }
light_source { <-30, 20, -25> color red 1.5 green 1.5 blue 1.5 }
light_source { < 20,-30, -25> color red .1 green .1 blue 1 }

#declare flash = light_source { <-5, 5, -25> color red 1 green 1 blue 1 }

#declare slider = object { rcylslider }
#declare slbody = difference {
   object { rcylbody }
   box { <-2*size-2*minor, -2*minor, flat-minor>
         < 2*size+2*minor,  2*minor, flat+2*minor>
         texture { Solid2 }
   }
}

#declare back = box {
   <-20, -20, 0>, <20, 20, 100>
   texture {
      pigment { red 1 green 0 blue 1 }
      finish { ambient 1.0 diffuse 0.0 }
   }
}

