// button form

#include "solid.inc"

#declare flat = 0.5
#declare dens = 1.0
#declare size = 1.0
#declare sizel = -1.5
#declare raise = 0.5
#declare hole = 0.5
#declare lampraise = -0.75

#declare rcylbutton = merge {
  cylinder {
    <sizel, 0, 0>, <size, 0, 0>, size
    scale <1, 1, flat>
  }
  difference {
    sphere {
      <sizel/dens, 0, 0>, size
      scale <dens, 1, flat>
      translate <0, 0, -raise>
    }
    sphere {
      <sizel/dens, 0, -size>, hole
      scale <dens, 1, flat>
      translate <0, 0, -raise>
    }
  }
  sphere {
    < size/dens, 0, 0>, size
    scale <dens, 1, flat>
  }
  texture { Solid }
}

#declare lamp = sphere {
  <sizel/dens, 0, 2*lampraise>, hole
  scale <dens, 1, flat>
}

#declare rcylbed = merge {
  cylinder { <sizel/dens, 0, 2>, <sizel/dens, 0, -1>, size
             scale <dens, 1, 1> }
  cylinder { < size/dens, 0, 2>, < size/dens, 0, -1>, size
             scale <dens, 1, 1> }
  box {
    <sizel, -size, 2>, <size, size, -1>
  }
  texture { Solid1 }
}

light_source { <-15, 30, -25> color red 1.5 green 1.5 blue 1.5 }
light_source { <-30, 20, -25> color red 1.5 green 1.5 blue 1.5 }
light_source { < 20,-30, -25> color red .1 green .1 blue 1 }

#declare flash = light_source { <-5, 5, -25> color red 1 green 1 blue 1 }

#declare button = object { rcylbutton }
#declare bed = object { rcylbed }

difference {
  box {
    <-20, -20, 0>, <20, 20, 0.1>
    texture {
      pigment { red 1 green 0 blue 1 }
      finish { ambient 1.0 diffuse 0.0 }
    }
  }
  object { bed }
}

